function [sh]=calcshear(vu,Z,dj) 
% CALCSHEAR Calculates the vertical shear for an RHI
% Use: sh=calcshear(vu,Z,dj)
% dj is an optional argument which determines how many points to
% use for the centered gradient scheme.

if (nargin == 2)
	dj=1;
end

sh=vu.*NaN;
sh1=sh;
sh2=sh;
[mm nn]=size(vu);
vmin=min(min(vu));

i=1:mm;
j=(1+dj):nn-(1+dj);

if (dj == 1)
	vel=unfold(vu,vmin+15);
	sh1(i,j)=(vel(i,j+dj)-vel(i,j-dj))./(Z(i,j+dj)-Z(i,j-dj));
	vel=vu;
	sh2(i,j)=(vel(i,j+dj)-vel(i,j-dj))./(Z(i,j+dj)-Z(i,j-dj));
	
	index=find((abs(sh1) < abs(sh2)));
	sh=sh2;
	sh(index)=sh1(index);
else
	vel=munfill(vu);
	sh(i,j)=(vel(i,j+dj)-vel(i,j-dj))./(Z(i,j+dj)-Z(i,j-dj));
end


