%RHIPLOT: Plots Doppler RHI scans
%Intended mainly for use with dataplot.m, but works as a standalone program
%too.
% Requires v2, phi_dp, elev, range etc (e.g. from loadchil)
% Produces X, Z, vu (unfolded/zapped velocity), sh (shear, if plotted), 
% and div (divergence, if plotted).


danplot_vars
%---------------------------------

if plotall==0
   clf;
   
   amt=uimenu('Label','Top Axes');
   uimenu(amt,'Label','Shading interp','Callback','set(pctop,''FaceColor'',''interp'')')
   uimenu(amt,'Label','Shading flat','Callback','set(pctop,''FaceColor'',''flat'')')
   uimenu(amt,'Label','Caxis...','Callback','axes(axrtop),prompt={''Minimum value'',''Maximum value''}; , ca=caxis; , def={ca(1),ca(2)}; , mtitle=''Caxis input'';,lineNo=1;,answ=inputdlg(prompt,mtitle,lineNo,def);,caxis([str2num(answ{1}) str2num(answ{2})]),colorbar;,set(cv,''tickdir'',''out'');,pos=get(cv,''position'');,set(cv,''position'',[pos(1) pos(2) .04 pos(4)]);')
   uimenu(amt,'Label','Match bottom axes','Callback','xlim=get(axrbot,''xlim'');,ylim=get(axrbot,''ylim'');,axes(axrtop);,axis([xlim,ylim]);')
   uimenu(amt,'Label','Get Data','Callback','axes(axrtop); getdata')
   uimenu(amt,'Label','Generate Profile','Callback','axes(axrtop); dopplerprofile')
   
   amb=uimenu('Label','Bottom Axes');
   uimenu(amb,'Label','Shading interp','Callback','set(pcbot,''FaceColor'',''interp'')')
   uimenu(amb,'Label','Shading flat','Callback','set(pcbot,''FaceColor'',''flat'')')
   uimenu(amb,'Label','Caxis...','Callback','axes(axrbot), prompt={''Minimum value'',''Maximum value''}; , ca=caxis; , def={ca(1),ca(2)}; , mtitle=''Caxis input'';,lineNo=1;,answ=inputdlg(prompt,mtitle,lineNo,def); ,caxis([str2num(answ{1}) str2num(answ{2})]),colorbar,set(csh,''tickdir'',''out'');,pos=get(csh,''position'');,set(csh,''position'',[pos(1) pos(2) .04 pos(4)]);')
   
   uimenu(amb,'Label','Match top axes','Callback','xlim=get(axrtop,''xlim'');,ylim=get(axrtop,''ylim'');,axes(axrbot);,axis([xlim,ylim]);')
   uimenu(amb,'Label','Get Data','Callback','axes(axrbot); getdata')
   uimenu(amb,'Label','Generate Profile','Callback','axes(axrbot); dopplerprofile')
   
   amboth=uimenu('Label','Both Axes');
   uimenu(amboth,'Label','Match reflectivity axes','Callback','xlim=get(axrztop,''xlim'');,ylim=get(axrztop,''ylim'');,axes(axrtop);,axis([xlim,ylim]);;,axes(axrbot);,axis([xlim,ylim])')
   uimenu(amboth,'Label','Max Z...','Callback','axes(axrtop), prompt={''Maximum height''}; , ca=axis; , def={ca(4)}; , mtitle=''Max Z input'';,lineNo=1;,answ=inputdlg(prompt,mtitle,lineNo,def);rhizmax=str2num(answ{1}); ,set(axrtop,''ylim'',[0 rhizmax]); ,set(axrbot,''ylim'',[0 rhizmax]);')
   
   uimenu(amboth,'Label','Max Range...','Callback','axes(axrtop), prompt={''Maximum range''}; , ca=axis; , def={rhirmax}; , mtitle=''Max Range input'';,lineNo=1;,answ=inputdlg(prompt,mtitle,lineNo,def);rhirmax=str2num(answ{1}); ,set(axrtop,''xlim'',[ca(1) rhirmax]); ,set(axrbot,''xlim'',[ca(1) rhirmax]);')
   
   uimenu(amboth,'Label','X-Dir (normal)','Callback','rhixdir=''normal'';set(axrtop,''xdir'',''normal'');set(axrbot,''xdir'',''normal'')');
   uimenu(amboth,'Label','X-Dir (reverse)','Callback','rhixdir=''reverse'';set(axrtop,''xdir'',''rev'');set(axrbot,''xdir'',''rev'')');
   
   colmenu=uimenu(amboth,'Label','Colormaps...');
   uimenu(colmenu,'Label','Flip Colormap','Callback','colormap(flipud(colormap));');
   uimenu(colmenu,'Label','Jet15','Callback','load colmap;colormap(jet15);axes(axrbot);colorbar;axes(axrtop);colorbar');
   uimenu(colmenu,'Label','Jet(64)','Callback','colormap(jet(64));axes(axrbot);colorbar;axes(axrtop);colorbar');
   uimenu(colmenu,'Label','map12','Callback','load colmap;colormap(map12);axes(axrbot);colorbar;axes(axrtop);colorbar');
   uimenu(colmenu,'Label','map15','Callback','load colmap;colormap(map15);axes(axrbot);colorbar;axes(axrtop);colorbar');
   
   %uimenu(amboth,'Label','Flip Colormap','Callback','colormap(flipud(colormap));');
   
   uimenu(amboth,'Label','Streamlines...','Callback','streammenu;');
   uimenu(amboth,'Label','Run trackdata','Callback','trackdata;');
   
   nav=uimenu('label','Navigate');
   
   uimenu(nav,'label','Forward','callback','num=num+1-(num >= ns);,raster=ra(num);,gettext;,set(infoh,''string'',txt);','accelerator','f');
   
   uimenu(nav,'label','Back','callback','num=num-1+(num <= 1);,raster=ra(num);,gettext;,set(infoh,''string'',txt);','accelerator','b');
   
   ploth=uimenu('label','Plot');
   
   uimenu(ploth,'label','Doppler','callback','set(danploth,''pointer'',''watch'');,drawnow;,scan=sc(num);,dfilen=''data.mat'';,filename=fname;,extract;,plot_data;,set(danploth,''pointer'',''arrow'');','accelerator','d');
   
   uimenu(ploth,'label','Reflectivity','callback','set(danploth,''pointer'',''watch'');,drawnow;,scan=sc(num);,dfilen=''dataz.mat'';,filename=fnamez;,extract;,plot_dataz;,set(danploth,''pointer'',''arrow'');','accelerator','r');
   
   drawnow;
   
end
%==================================================================

%colormap(jet(100));
[mm nn]=size(v2);
posbot=[.11 .12 .85 .32];
postop=[.11 .59 .85 .32];
%-------------------------------

angles=elev(1:nn)';
X=range'*cos(angles'*pi/180);
Z=range'*sin(angles'*pi/180);

%correction - basically as on Chilbolton web pages/Battan
Z=Z+3*X.^2/(8*6371);

xmin=5;xmax=30;zmin=0;zmax=2;

xmin=min(min(X));xmax=max(max(X));zmin=0;zmax=rhizmax;
xmax=min([xmax,rhirmax]);


vmin=vminrhi;
vf=30;
vmax=vmin+vf;
vu=vscalerhi*unfold(v2,vmin,vf);

%===================zap/unfold velocities==========================

if runzaprhi == 0 & rununfoldrhi == 0
   %all's well with the world, so do nothing
   
elseif runzaprhi == 1 & rununfoldrhi == 0
   %zap but don't unfold
   disp('zapping data')
   vu=mzap(vu,zapparams(1),zapparams(2),zapparams(3));
elseif runzaprhi == 0 & rununfoldrhi ~= 0
   %unfold, but don't zap
   disp('unfolding... but not zapping...');
   %	vu=munfold(vu);
   [vu region]=munfill(vu);
   vu2=mzap(vu,zapparams(1),zapparams(2),zapparams(3));
   index=find(isnan(vu2)==0);
   vu=vu-30.0*floor(mean(mean(vu2(index)+15))/30.0);
   vu2=vu2-30.0*floor(mean(mean(vu2(index)+15))/30.0);
   vu2=mzap(vu2,4,3,0);
   vmin=min(min(vu2));
   vmax=max(max(vu2));
elseif runzaprhi == 1 & rununfoldrhi ~= 0
   %unfold and zap
   disp('unfolding...');
   %	vu=munfold(vu);
   [vu region]=munfill(vu);
   disp(' and zapping...')
   vu=mzap(vu,zapparams(1),zapparams(2),zapparams(3));
   index=find(isnan(vu)==0);
   vu=vu-30.0*floor(mean(mean(vu(index)+15))/30.0);
   %vu=vu+30;
   vu2=mzap(vu,4,3,0);
   vmin=min(min(vu2));
   vmax=max(max(vu2));
end

vu=smooth2d(vu,vsmoothrhi_r,vsmoothrhi_e);

vu=vu+voffsetrhi;
vmin=vmin+voffsetrhi;
vmax=vmax+voffsetrhi;

if rhipl2=='sh'
   %==========calculate shear (removing the effects of folding)=============
   disp('calculating shear...');
   if clevershear==1
      
      sh=calcshear(vu,Z);
      
   else
      
      sh=vu.*0;
      for i=1:mm
         sh(i,:)=gradient(vu(i,:),Z(i,:));
      end
      
   end
   
   %================auto-range shear=================
   
   if autoshear==1
      
      shrange=calcshear(mzap(vu,4,5,0),Z);
      shminauto=max(min(min(shrange(3:mm-2,3:nn-2))),-40);
      shmaxauto=min(max(max(shrange(3:mm-2,3:nn-2))),40);
      
   end
   
   %===========now plot shear================
   disp('plotting shear...');
   axrbot=axes('position',posbot);
   set(gca,'xdir',rhixdir);
   eval(['grid ' showgrid]);
   axis([xmin xmax zmin zmax]);
   set(gca,'TickDir','out');
   set(gca,'Box','on');
   set(gca,'YTick',zmin:1:zmax);
   hold on
   
   text='dv/dz (m/s/km)';
   title(['Tape ',int2str(file),' Raster ',int2str(raster),' Scan ',int2str(scan),' ',int2str(day),'/',int2str(month),'/',int2str(year),' ',int2str(start_hour),':',int2str(start_min),':',int2str(start_sec),' Az ',num2str(azim(:,1)-90),' deg : ',text]);
   
   pcbot=pcolor(X,Z,sh);shading('flat');
   
   if autoshear==1
      caxis([shminauto shmaxauto]);
   else
      caxis([shmin shmax]);
   end
   
   ylabel('Height(km)');
   xlabel('Distance from radar (km)');
   
   csh=colorbar('ver');
   set(csh,'tickdir','out');
   pos=get(csh,'position');
   set(csh,'position',[pos(1) pos(2) .04 pos(4)]);
end 
%===============finished plotting shear==========================

if rhipl2=='di'
   %==============calculate divergence=============================
   
   %div=vu.*0;
   %v=vu;
   %for i=1:nn
   %div(:,i)=gradient(v(:,i)',X(:,i)')';
   %end
   
   div=vu.*0;
   di1=div;
   di2=div;
   
   v=unfold(vu,vmin+15);
   for i=1:nn
      di1(:,i)=gradient(v(:,i)',X(:,i)')';
   end
   
   v=vu;
   for i=1:nn
      di2(:,i)=gradient(v(:,i)',X(:,i)')';
   end
   
   index=find((abs(di1) < abs(di2)));
   div=di2;
   div(index)=di1(index);
   %sh=smooth2(sh,.1);
   
   %div=div/1000.;
   
   axrbot=axes('position',posbot);
   eval(['grid ' showgrid]);
   set(gca,'xdir',rhixdir);
   axis([xmin xmax zmin zmax]);
   set(gca,'TickDir','out');
   set(gca,'Box','on');
   set(gca,'YTick',zmin:1:zmax);
   hold on
   
   text='dv/dx (m/s/km)';
   title(['Tape ',int2str(file),' Raster ',int2str(raster),' Scan ',int2str(scan),' ',int2str(day),'/',int2str(month),'/',int2str(year),' ',int2str(start_hour),':',int2str(start_min),':',int2str(start_sec),' Az ',num2str(azim(:,1)-90),' deg : ',text]);
   
   pcbot=pcolor(X,Z,div);shading('flat');
   % p=colplot(X,Z,v1); set(p,'edgecolor','none');
   caxis([-15 15]);
   ylabel('Height(km)');
   xlabel('Distance from radar (km)');
   
   csh=colorbar('ver');
   set(csh,'tickdir','out');
   pos=get(csh,'position');
   set(csh,'position',[pos(1) pos(2) .04 pos(4)]);
end 


if rhipl2=='ph'
   %==============plot phi_dp=============================
   
   axrbot=axes('position',posbot);
   eval(['grid ' showgrid]);
   set(gca,'xdir',rhixdir);
   axis([xmin xmax zmin zmax]);
   set(gca,'TickDir','out');
   set(gca,'Box','on');
   set(gca,'YTick',zmin:1:zmax);
   hold on
   
   mask=mzap(v2,5,0,0);
   index=find(isnan(mask));
	 phi_dp(index)=NaN;
   text='phi\_dp';
   title(['Tape ',int2str(file),' Raster ',int2str(raster),' Scan ',int2str(scan),' ',int2str(day),'/',int2str(month),'/',int2str(year),' ',int2str(start_hour),':',int2str(start_min),':',int2str(start_sec),' Az ',num2str(azim(:,1)-90),' deg : ',text]);
   
   pcbot=pcolor(X,Z,phi_dp);shading('flat');
   % caxis([-50 50]);
   ylabel('Height(km)');
   xlabel('Distance from radar (km)');
   
   csh=colorbar('ver');
   set(csh,'tickdir','out');
   pos=get(csh,'position');
   set(csh,'position',[pos(1) pos(2) .04 pos(4)]);
end 



%------------Plot velocity on top axes--------------------
axrtop=axes('position',postop);
eval(['grid ' showgrid]);
set(gca,'xdir',rhixdir);

hold off
axis([xmin xmax zmin zmax]);
set(gca,'TickDir','out');
set(gca,'Box','on');
set(gca,'YTick',zmin:1:zmax);
hold on
if vscalerhi>0
   text='v (m/s +ve towards radar)';
else
   text='v (m/s +ve away from radar)';
end

title(['Tape ',int2str(file),' Raster ',int2str(raster),' Scan ',int2str(scan),' ',int2str(day),'/',int2str(month),'/',int2str(year),' ',int2str(start_hour),':',int2str(start_min),':',int2str(start_sec),' Az ',num2str(azim(:,1)-90),' deg : ',text]);

pctop=pcolor(X,Z,vu);
caxis([vmin vmax]);
shading('flat');
cv=colorbar('ver');
set(cv,'tickdir','out');
pos=get(cv,'position');
set(cv,'position',[pos(1) pos(2) .04 pos(4)]);
ylabel('Height (km)');

disp(['section from (radar) ' num2str(latitude) ' N, ' num2str(longitude) ' E to ' num2str(latitude+xmax*sin(azim(1)*pi/180)/111.2) ' N, ' num2str(longitude-xmax*cos(azim(1)*pi/180)/67.7 ) ' E.' ])
%---------------------------------------

set(gcf,'papertype','a4');
%set(gcf,'paperorientation','landscape');
%set(gcf,'paperposition',[0.81176 0.97647 10.035 6.2941]);

set(gcf,'paperorientation','portrait');
set(gcf,'paperposition',[0.25 2.9336 7.7677 5.8258]);

plotall=0;





