% STREAMCALC
% Note, u has to be positive in positive x dir, so this code assumes
% that we haven't set this in the options, ie the code uses v=-vu
% Also, calculations must be done in system relative coords, so the
% background speed specified is subtracted from v, i.e. the code uses
% v=(-vu)-backspeed 
% Alternatively, backspeed is the speed at which the system is
% travelling from left to right in a conventionally plotted RHI.

% Note this code isn't used by streammenu (which calls streamtrace),
% so why is it still here?

v=-vu-backspeed;

xrmin=12;xrmax=40;dxr=.25;
zrmin=0;zrmax=4;dzr=0.1;

xr=xrmin:dxr:xrmax;
zr=zrmin:dzr:zrmax;

vr=minterp(v,range,elev,xr,zr);
if num > 0
	vr=replace(vr,num);
end
if smoothing > 0
	vr=smooth2d(vr,smoothing/4,smoothing);
end

figure(10)
clf

runin=input('Input streamline, otherwise use existing data? (y/n) ', 's');


axis([xrmin-2 xrmax+2 zrmin zrmax]);
hold on
p=pcolor(X,Z,smooth2(sh,.5));
%shading flat;
caxis([-20 20]);
hold on;

button=1;
i=0;
if runin=='y',

disp('Click along a streamline (from l to r) - Right button exits');

[x,z,button]=ginput(1);
ph=[];
xin=[];
zin=[];

while button~=3

	i=i+1;

	xin(i)=x;
	zin(i)=z;

	ph(i,:)=plot(x,z,'kx',x,z,'wo')';

	[x,z,button]=ginput(1);

end

delete(ph);

end

shading flat

zrout=interp1(xin,zin,xr,'cubic');

dzdx=gradient(zrout,dxr);

zi=round((zrout-zmin)/dzr);

ph2=plot(xr,zrout,'k');
disp('Press return...');
pause

delete(ph2);

%might as well treat streamline as zero, say

sf=vr*NaN;
[xrg zrg]=meshgrid(xr,zr);
dens=1.2*exp(-zrg/8.0)';

%go down....
for i=1:length(xr)
	sf(i,zi(i))=0-vr(i,zi(i))*dens(i,zi(i))*(zrout(i)-zr(zi(i)));
	for j=zi(i):-1:2
		 sf(i,j-1)=sf(i,j)-dzr*vr(i,j)*dens(i,j);
	end
end

%now up......
for i=1:length(xr)
	for j=zi(i):(length(zr)-1)
		 sf(i,j+1)=sf(i,j)+dzr*vr(i,j)*dens(i,j);
	end
end

wr=-ddx(sf',xr)'./dens;

[c,h1]=contour(xr,zr,sf',[-30:1:-1],'k');
[c,h2]=contour(xr,zr,sf',[1:1:30],'--k');
[c,h3]=contour(xr,zr,sf',[0 0],'k');
[c,h4]=contour(xr,zr,sf',[0 0],'--w');

set(h3,'linewidth',1);
