%TRACKDATA enables data tracking from the output of rhiplot etc
%
% After running rhiplot, ppiplot etc, running trackdata does two things:
% 1) It turns off the zoom mode on all the standard plotting windows
% 2) It runs the script animate.m every time the mouse button is
% clicked or moved over a plot produced by rhiplot etc. This displays
% the mouse position and the value at that location.
%
% If the coordinates appear to be coming from another plot, try
% clicking in an area that wouldn't be covered by an extension of the
% intruding plot (does this make sense to anyone but me!!). This might
% not be possible if one of the axes is excessively zoomed in - then
% set the axes directly, e.g. axes(axrtop)

if exist('win_rhi') & ishandle(win_rhi); zoom(win_rhi,'off'); end
if exist('win_ppi') & ishandle(win_ppi); zoom(win_ppi,'off'); end
if exist('win_fix') & ishandle(win_fix); zoom(win_fix,'off'); end
if exist('win_slant') & ishandle(win_slant); zoom(win_slant,'off'); end

if exist('win_rhiz') & ishandle(win_rhiz); zoom(win_rhiz,'off'); end
if exist('win_ppiz') & ishandle(win_ppiz); zoom(win_ppiz,'off'); end
if exist('win_fixz') & ishandle(win_fixz); zoom(win_fixz,'off'); end
if exist('win_slantz') & ishandle(win_slantz); zoom(win_slantz,'off'); end

if exist('win_rhiv') & ishandle(win_rhiv); zoom(win_rhiv,'off'); end
if exist('win_ppiv') & ishandle(win_ppiv); zoom(win_ppiv,'off'); end
if exist('win_fixv') & ishandle(win_fixv); zoom(win_fixv,'off'); end
if exist('win_slantv') & ishandle(win_slantv); zoom(win_slantv,'off'); end

if exist('pctop') & (ishandle(pctop));	set(pctop,'buttondownfcn','animator start'); end
if exist('pcbot') & (ishandle(pcbot));	set(pcbot,'buttondownfcn','animator start'); end
if exist('pctopz') & (ishandle(pctopz));	set(pctopz,'buttondownfcn','animator start'); end
if exist('pcbotz') & (ishandle(pcbotz));	set(pcbotz,'buttondownfcn','animator start'); end
if exist('pctopv') & (ishandle(pctopv));	set(pctopv,'buttondownfcn','animator start'); end
if exist('pcbotv') & (ishandle(pcbotv));	set(pcbotv,'buttondownfcn','animator start'); end

if exist('pc_ppi') & (ishandle(pc_ppi));	set(pc_ppi,'buttondownfcn','animator start'); end
if exist('pc_ppiz') & (ishandle(pc_ppiz));	set(pc_ppiz,'buttondownfcn','animator start'); end
if exist('pc_ppiv') & (ishandle(pc_ppiv));	set(pc_ppiv,'buttondownfcn','animator start'); end

disp('Zoom has been turned off for all the standard plotting windows.')
disp(' ')
disp('Click and optionally drag the mouse in any of the plots to get the location and value. Rerun trackdata if you plot the data again, as it reverts back to the zoom mode, with no tracking, by default.')